【Codeforces】716D Complete The Graph

D. Complete The Graph

time limit per test: 4 seconds
memory limit per test: 256 megabytes
input: standard input
output: standard output

ZS the Coder has drawn an undirected graph of n vertices numbered from 0 to n - 1 and m edges between them. Each edge of the graph is weighted, each weight is a positive integer.

The next day, ZS the Coder realized that some of the weights were erased! So he wants to reassign positive integer weight to each of the edges which weights were erased, so that the length of the shortest path between vertices s and t in the resulting graph is exactly L. Can you help him?

Input

The first line contains five integers n, m, L, s, t (2 ≤ n ≤ 1000,  1 ≤ m ≤ 10 000,  1 ≤ L ≤ 109,  0 ≤ s, t ≤ n - 1,  s ≠ t) — the number of vertices, number of edges, the desired length of shortest path, starting vertex and ending vertex respectively.

Then, m lines describing the edges of the graph follow. i-th of them contains three integers, ui, vi, wi(0 ≤ ui, vi ≤ n - 1,  ui ≠ vi,  0 ≤ wi ≤ 109). ui and vi denote the endpoints of the edge and wi denotes its weight. If wi is equal to 0 then the weight of the corresponding edge was erased.

It is guaranteed that there is at most one edge between any pair of vertices.

Output

Print "NO" (without quotes) in the only line if it's not possible to assign the weights in a required way.

Otherwise, print "YES" in the first line. Next m lines should contain the edges of the resulting graph, with weights assigned to edges which weights were erased. i-th of them should contain three integers ui, vi and wi, denoting an edge between vertices ui and vi of weight wi. The edges of the new graph must coincide with the ones in the graph from the input. The weights that were not erased must remain unchanged whereas the new weights can be any positive integer not exceeding 1018.

The order of the edges in the output doesn't matter. The length of the shortest path between s and t must be equal to L.

If there are multiple solutions, print any of them.

Examples

input
5 5 13 0 4
0 1 5
2 1 2
3 2 3
1 4 0
4 3 4
output
YES
0 1 5
2 1 2
3 2 3
1 4 8
4 3 4
input
2 1 999999999 1 0
0 1 1000000000
output
NO

Note

Here's how the graph in the first sample case looks like :

In the first sample case, there is only one missing edge weight. Placing the weight of 8 gives a shortest path from 0 to 4 of length 13.

In the second sample case, there is only a single edge. Clearly, the only way is to replace the missing weight with 123456789.

In the last sample case, there is no weights to assign but the length of the shortest path doesn't match the required value, so the answer is "NO".

Understanding

 给一个无向图,有一些权值为0的边要重构成正数权值,使得s→t的最短路为l

Solution

特判掉原本最短路(没有加入0边)<l→"NO"

分析一下,s→t的最短路,贪心,加入0边,先不管取值,先一条条赋为1(最小positive integer),如果当前最短路<l是不是说明当前这条边是最短路的一部分,所以答案就出来了,将这条边赋值为l-d[t]+1,如果最短路仍>l,而这已经是这条边的最优贡献,所以赋值为1继续做.

然后注意一下细节即可(WA了4发~~)

复杂度:O(nmlogn)(优化:对了,每次做最短路,当前值已经>l可以直接退出,所以其实跑得很快296MS)

// This file is made by YJinpeng,created by XuYike's black technology automatically.
// Copyright (C) 2016 ChangJun High School, Inc.
// I don't know what this program is.

#include <iostream>
#include <vector>
#include <algorithm>
#include <cstring>
#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <queue>
#define IN inline
#define RG register
#define MOD 1000000007
#define INF 1e9+1
using namespace std;
typedef long long LL;
const int MAXN=1010;
const int MAXM=20010;
inline int gi() {
	register int w=0,q=0;register char ch=getchar();
	while((ch<'0'||ch>'9')&&ch!='-')ch=getchar();
	if(ch=='-')q=1,ch=getchar();
	while(ch>='0'&&ch<='9')w=w*10+ch-'0',ch=getchar();
	return q?-w:w;
}
int tot,cnt,S[MAXM],T[MAXM];
struct Dijskra{
    static const int N=1010,M=(N*10)<<1;
    int n,t,l;int d[N],fr[N];int to[M],ne[M],be[M],W[M];bool u[N];
    struct node{
        int s,p;
        bool operator<(node a)const{return s>a.s;}
    };
    priority_queue<node>q;
    IN void link(RG int u,RG int v,RG int w){
        //if(w>l)return; this some edges didn't get
        to[++t]=v;ne[t]=fr[u];fr[u]=t;W[t]=w;be[t]=u;
    }
    int Dij(int begin,int end){
        for(int i=0;i<n;i++)d[i]=INF;
        q.push((node){d[begin]=0,begin});memset(u,0,sizeof(u));
        while(!q.empty()){
            while(u[q.top().p]&&!q.empty())q.pop();
            if(q.empty())break;
            int x=q.top().p;q.pop();u[x]=1;
            if(x==end||d[x]>l)break;
            for(int o=fr[x],y;y=to[o],o;o=ne[o])
                if(d[x]+W[o]<d[y]&&d[x]+W[o]<=l){
                    d[y]=d[x]+W[o];
                    q.push((node){d[y],y});
                }
        }
        return d[end];
    }
    void pri(int end){
        printf("YES\n");
        for(int i=1;i<t-1;i+=2)
            printf("%d %d %d\n",be[i],to[i],W[i]);
        printf("%d %d %d\n",be[t-1],to[t-1],l-d[end]+W[t-1]);//this W[t-1]
        for(int i=tot;i<=cnt;i++)printf("%d %d %d\n",S[i],T[i],(int)INF);exit(0);
    }
}e;
int main()
{
	freopen("D.in","r",stdin);
	freopen("D.out","w",stdout);
	int n=gi(),m=gi(),l=gi(),s=gi(),t=gi();e.l=l;e.n=n;
    for(int i=1;i<=m;i++){
        int u=gi(),v=gi(),w=gi();
        if(w)e.link(u,v,w),e.link(v,u,w);
        else S[++cnt]=u,T[cnt]=v;
    }tot=1;//this
    if(e.Dij(s,t)<l){printf("NO");return 0;}
    if(e.d[t]==l)e.pri(t);
    for(;tot<=cnt;tot++){
        e.link(S[tot],T[tot],1);e.link(T[tot],S[tot],1);
        if(e.Dij(s,t)<=l)break;
    }tot++;
    if(tot>cnt+1)return 0*puts("NO");
    e.pri(t);
	return 0;
}

 

posted @ 2016-10-16 10:39  _Mashiro  阅读(661)  评论(0编辑  收藏  举报